<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="../../">
<head>
  <meta charset="utf-8" /><meta name="viewport" content="width=device-width, initial-scale=1" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Scenario &mdash; openPASS Documentation</title>
      <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=b86133f3" />
      <link rel="stylesheet" type="text/css" href="../../_static/css/theme.css?v=19f00094" />
      <link rel="stylesheet" type="text/css" href="../../_static/css/custom.css?v=4ad39fc2" />

  
    <link rel="shortcut icon" href="../../_static/openPASS.ico"/>
  <!--[if lt IE 9]>
    <script src="../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="../../_static/jquery.js?v=5d32c60e"></script>
        <script src="../../_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
        <script src="../../_static/documentation_options.js?v=6efca38a"></script>
        <script src="../../_static/doctools.js?v=888ff710"></script>
        <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="Scenario API Support" href="scenario_api_support.html" />
    <link rel="prev" title="ProfilesCatalog" href="profilescatalog.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../index.html" class="icon icon-home">
            openPASS
              <img src="../../_static/openPASS.png" class="logo" alt="Logo"/>
          </a>
              <div class="version">
                1.2.0
              </div>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Installation Guide</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/10_getting_started.html">Getting Started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/15_system_requirements.html">System Requirements</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/20_install_prerequisites.html">Installing Prerequisites</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/30_install_openpass.html">Installing openPASS</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/50_further_guidance.html">Further Guidance</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/60_conan.html">Building with Conan</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">User Guides</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../10_overview.html">Overview</a></li>
<li class="toctree-l1"><a class="reference internal" href="../20_tutorials.html">Tutorials</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../30_configs_in_depth.html">Configs in Depth</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="profilescatalog.html">ProfilesCatalog</a></li>
<li class="toctree-l2 current"><a class="current reference internal" href="#">Scenario</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#overview">Overview</a></li>
<li class="toctree-l3"><a class="reference internal" href="#parameterdeclarations">ParameterDeclarations</a></li>
<li class="toctree-l3"><a class="reference internal" href="#catalogs">Catalogs</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#vehiclecatalog">VehicleCatalog</a></li>
<li class="toctree-l4"><a class="reference internal" href="#pedestriancatalog">PedestrianCatalog</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="#roadnetwork">RoadNetwork</a></li>
<li class="toctree-l3"><a class="reference internal" href="#entities">Entities</a></li>
<li class="toctree-l3"><a class="reference internal" href="#storyboard">Storyboard</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#init">Init</a></li>
<li class="toctree-l4"><a class="reference internal" href="#story">Story</a></li>
<li class="toctree-l4"><a class="reference internal" href="#stoptrigger">StopTrigger</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="#current-restrictions">Current Restrictions</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#conditions">Conditions</a></li>
<li class="toctree-l4"><a class="reference internal" href="#actions">Actions</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="scenario_api_support.html">Scenario API Support</a></li>
<li class="toctree-l2"><a class="reference internal" href="scenery.html">Scenery</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulationconfig.html">SimulationConfig</a></li>
<li class="toctree-l2"><a class="reference internal" href="staticsystemconfig.html">Static SystemConfig</a></li>
<li class="toctree-l2"><a class="reference internal" href="systemconfigblueprint.html">SystemConfigBlueprint</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../40_outputs_in_depth.html">Outputs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../50_scenario_simulation.html">Simulator</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Advanced topics</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../advanced_topics/20_simulator_advanced.html">Simulator</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../advanced_topics/30_testing.html">EndToEnd Test Framework</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Developer Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/10_ide_support.html">IDE Support</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/20_documentation.html">Documentation Concept</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/30_coding_conventions.html">Coding Guidelines</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Other Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/10_external_dependencies.html">External Dependencies</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/20_glossary.html">Glossary</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/30_gui_plugins.html">GUI Plugins</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/40_license.html">License</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">openPASS</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../30_configs_in_depth.html">Configs in Depth</a></li>
      <li class="breadcrumb-item active">Scenario</li>
      <li class="wy-breadcrumbs-aside">
            <a href="../../_sources/user_guide/configs/scenario.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="scenario">
<span id="id1"></span><h1>Scenario<a class="headerlink" href="#scenario" title="Link to this heading"></a></h1>
<section id="overview">
<span id="scenario-overview"></span><h2>Overview<a class="headerlink" href="#overview" title="Link to this heading"></a></h2>
<p>The scenario configuration file (<code class="docutils literal notranslate"><span class="pre">*.xosc</span></code>) describes all dynamic configurations of a simulation run, i.e. position of various road users as well as conditional events that change the behavior of the simulation during the run.
The scenario control is carried out using the <a class="reference external" href="https://gitlab.eclipse.org/eclipse/openpass/openscenario1_engine">OpenScenarioEngine</a>, which processes scenarios according to <a class="reference external" href="https://www.asam.net/standards/detail/openscenario/">ASAM OpenSCENARIO</a>.
It is interfaced using the <a class="reference external" href="https://gitlab.eclipse.org/eclipse/openpass/mantle-api">MantleAPI</a>.
For the list of MantleAPI features supported by <strong>openPASS</strong> see <a class="reference internal" href="scenario_api_support.html#scenario-api-support"><span class="std std-ref">Scenario API Support</span></a>.</p>
<p>At the time of writing, the OpenScenarioEngine processes scenario configurations in version 1.1.1, but please refer to the corresponding documentations for possible and implemented features.</p>
<p>In the following, the most important features for openPASS are described.</p>
</section>
<section id="parameterdeclarations">
<span id="scenario-parameterdeclaration"></span><h2>ParameterDeclarations<a class="headerlink" href="#parameterdeclarations" title="Link to this heading"></a></h2>
<p>The tag <code class="docutils literal notranslate"><span class="pre">ParameterDeclarations</span></code> allow to define generic parameters, which can be referenced later the file by its name, prefixed with <code class="docutils literal notranslate"><span class="pre">$</span></code>.</p>
<p><strong>Example declaration</strong></p>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="nt">&lt;ParameterDeclarations&gt;</span>
<span class="w">  </span><span class="nt">&lt;ParameterDeclaration</span><span class="w"> </span><span class="na">name=</span><span class="s">&quot;simulation_time&quot;</span><span class="w"> </span><span class="na">parameterType=</span><span class="s">&quot;double&quot;</span><span class="w"> </span><span class="na">value=</span><span class="s">&quot;123.4&quot;</span><span class="nt">/&gt;</span>
<span class="nt">&lt;/ParameterDeclarations&gt;</span>
</pre></div>
</div>
<p><strong>Example usage</strong></p>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="nt">&lt;StopTrigger&gt;</span>
<span class="w">  </span><span class="nt">&lt;ConditionGroup&gt;</span>
<span class="w">    </span><span class="nt">&lt;Condition</span><span class="w"> </span><span class="na">name=</span><span class="s">&quot;EndTime&quot;</span><span class="w"> </span><span class="na">delay=</span><span class="s">&quot;0&quot;</span><span class="w"> </span><span class="na">conditionEdge=</span><span class="s">&quot;rising&quot;</span><span class="nt">&gt;</span>
<span class="w">      </span><span class="nt">&lt;ByValueCondition&gt;</span>
<span class="w">        </span><span class="nt">&lt;SimulationTimeCondition</span><span class="w"> </span><span class="na">value=</span><span class="s">&quot;$simulation_time&quot;</span><span class="w"> </span><span class="na">rule=</span><span class="s">&quot;greaterThan&quot;</span><span class="nt">/&gt;</span>
<span class="w">      </span><span class="nt">&lt;/ByValueCondition&gt;</span>
<span class="w">    </span><span class="nt">&lt;/Condition&gt;</span>
<span class="w">  </span><span class="nt">&lt;/ConditionGroup&gt;</span>
<span class="nt">&lt;/StopTrigger&gt;</span>
</pre></div>
</div>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Supported ParameterTypes</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>string</p></td>
</tr>
<tr class="row-odd"><td><p>integer</p></td>
</tr>
<tr class="row-even"><td><p>double</p></td>
</tr>
</tbody>
</table>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Only <code class="docutils literal notranslate"><span class="pre">string</span></code> allows empty values.</p>
</div>
</section>
<section id="catalogs">
<span id="scenario-catalogs"></span><h2>Catalogs<a class="headerlink" href="#catalogs" title="Link to this heading"></a></h2>
<p>The <code class="docutils literal notranslate"><span class="pre">Catalogs</span></code> tag defines locations of various other files containing sub features of OpenSCENARIO for easier reusing (and written in the same format).</p>
<p>The following catalogs are the most important:</p>
<ul class="simple">
<li><p><a class="reference internal" href="#scenario-vehiclemodels"><span class="std std-ref">VehicleCatalog</span></a></p></li>
<li><p><a class="reference internal" href="#scenario-pedestrianmodels"><span class="std std-ref">PedestrianCatalog</span></a></p></li>
<li><p>TrajectoryCatalog for the case that a <em>FollowTrajectory action</em> is defined</p></li>
</ul>
<p>The VehicleCatalog is also used by <strong>openPASS</strong> itself for spawning of Common vehicles and therefore mandatory.</p>
<p><strong>Example</strong></p>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="nt">&lt;CatalogLocations&gt;</span>
<span class="w">  </span><span class="nt">&lt;VehicleCatalog&gt;</span>
<span class="w">    </span><span class="nt">&lt;Directory</span><span class="w"> </span><span class="na">path=</span><span class="s">&quot;Vehicles&quot;</span><span class="nt">/&gt;</span>
<span class="w">  </span><span class="nt">&lt;/VehicleCatalog&gt;</span>
<span class="w">  </span><span class="nt">&lt;PedestrianCatalog&gt;</span>
<span class="w">    </span><span class="nt">&lt;Directory</span><span class="w"> </span><span class="na">path=</span><span class="s">&quot;Vehicles&quot;</span><span class="nt">/&gt;</span>
<span class="w">  </span><span class="nt">&lt;/PedestrianCatalog&gt;</span>
<span class="w">  </span><span class="nt">&lt;ControllerCatalog&gt;</span>
<span class="w">    </span><span class="nt">&lt;Directory</span><span class="w"> </span><span class="na">path=</span><span class="s">&quot;&quot;</span><span class="nt">/&gt;</span>
<span class="w">  </span><span class="nt">&lt;/ControllerCatalog&gt;</span>
<span class="w">  </span><span class="nt">&lt;ManeuverCatalog&gt;</span>
<span class="w">    </span><span class="nt">&lt;Directory</span><span class="w"> </span><span class="na">path=</span><span class="s">&quot;&quot;</span><span class="nt">/&gt;</span>
<span class="w">  </span><span class="nt">&lt;/ManeuverCatalog&gt;</span>
<span class="w">  </span><span class="nt">&lt;MiscObjectCatalog&gt;</span>
<span class="w">    </span><span class="nt">&lt;Directory</span><span class="w"> </span><span class="na">path=</span><span class="s">&quot;&quot;</span><span class="nt">/&gt;</span>
<span class="w">  </span><span class="nt">&lt;/MiscObjectCatalog&gt;</span>
<span class="w">  </span><span class="nt">&lt;EnvironmentCatalog&gt;</span>
<span class="w">    </span><span class="nt">&lt;Directory</span><span class="w"> </span><span class="na">path=</span><span class="s">&quot;&quot;</span><span class="nt">/&gt;</span>
<span class="w">  </span><span class="nt">&lt;/EnvironmentCatalog&gt;</span>
<span class="w">  </span><span class="nt">&lt;TrajectoryCatalog&gt;</span>
<span class="w">    </span><span class="nt">&lt;Directory</span><span class="w"> </span><span class="na">path=</span><span class="s">&quot;&quot;</span><span class="nt">/&gt;</span>
<span class="w">  </span><span class="nt">&lt;/TrajectoryCatalog&gt;</span>
<span class="w">  </span><span class="nt">&lt;RouteCatalog&gt;</span>
<span class="w">    </span><span class="nt">&lt;Directory</span><span class="w"> </span><span class="na">path=</span><span class="s">&quot;&quot;</span><span class="nt">/&gt;</span>
<span class="w">  </span><span class="nt">&lt;/RouteCatalog&gt;</span>
<span class="nt">&lt;/CatalogLocations&gt;</span>
</pre></div>
</div>
<section id="vehiclecatalog">
<span id="scenario-vehiclemodels"></span><h3>VehicleCatalog<a class="headerlink" href="#vehiclecatalog" title="Link to this heading"></a></h3>
<p>This path is mandatory.
It has to contain a file named “VehicleModelsCatalog.xosc”.
This file contains the available vehicle model catalogs for the simulation.
For each vehicle the physical parameters are stored here.</p>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Supported Models</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>car_bmw_i3</p></td>
</tr>
<tr class="row-odd"><td><p>car_bmw_3</p></td>
</tr>
<tr class="row-even"><td><p>car_bmw_7_1</p></td>
</tr>
<tr class="row-odd"><td><p>car_bmw_7_2</p></td>
</tr>
<tr class="row-even"><td><p>car_mini_cooper</p></td>
</tr>
<tr class="row-odd"><td><p>bus</p></td>
</tr>
<tr class="row-even"><td><p>truck</p></td>
</tr>
<tr class="row-odd"><td><p>bicycle</p></td>
</tr>
</tbody>
</table>
<p><strong>Example Catalog:</strong></p>
<p><a class="reference download internal" download="" href="../../_downloads/8789748ec2bbe8f70ec8c0763329bc98/VehicleModelsCatalog.xosc"><code class="xref download docutils literal notranslate"><span class="pre">/../../../repo/sim/contrib/examples/Common/Vehicles/VehicleModelsCatalog.xosc</span></code></a></p>
</section>
<section id="pedestriancatalog">
<span id="scenario-pedestrianmodels"></span><h3>PedestrianCatalog<a class="headerlink" href="#pedestriancatalog" title="Link to this heading"></a></h3>
<p>It contains the available pedestrian model catalogs for the simulation.
For each pedestrian the physical parameters are stored here.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Within <strong>openPASS</strong>, pedestrian models are internally handled the same way as vehicle models, i.e. they behave like simplified vehicles.
<em>Meaningless</em> parameters, such as <em>number of gears</em>, are set to operational defaults.</p>
</div>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Supported Models</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>pedestrian_child</p></td>
</tr>
<tr class="row-odd"><td><p>pedestrian_adult</p></td>
</tr>
</tbody>
</table>
<p><strong>Full Example:</strong> <a class="reference download internal" download="" href="../../_downloads/e127566572084ecb8640fe52563f5060/PedestrianModelsCatalog.xosc"><code class="xref download docutils literal notranslate"><span class="pre">/../../../repo/sim/contrib/examples/Common/Vehicles/PedestrianModelsCatalog.xosc</span></code></a></p>
</section>
</section>
<section id="roadnetwork">
<span id="scenario-roadnetwork"></span><h2>RoadNetwork<a class="headerlink" href="#roadnetwork" title="Link to this heading"></a></h2>
<p>The <code class="docutils literal notranslate"><span class="pre">RoadNetwork</span></code> tag contains the mandatory reference to the <a class="reference external" href="https://www.asam.net/standards/detail/opendrive/">OpenDRIVE</a> <a class="reference internal" href="scenery.html#scenery"><span class="std std-ref">Scenery</span></a>.</p>
<p><strong>Example</strong></p>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="nt">&lt;RoadNetwork&gt;</span>
<span class="w">  </span><span class="nt">&lt;LogicFile</span><span class="w"> </span><span class="na">filepath=</span><span class="s">&quot;SceneryConfiguration.xodr&quot;</span><span class="nt">/&gt;</span>
<span class="w">  </span><span class="nt">&lt;SceneGraphFile</span><span class="w"> </span><span class="na">filepath=</span><span class="s">&quot;&quot;</span><span class="nt">/&gt;</span>
<span class="nt">&lt;/RoadNetwork&gt;</span>
</pre></div>
</div>
<p>Furthermore the controllers of the traffic lights are defined in this section.
Each controller defines the phases of a set of linked traffic lights (e.g. one junction).</p>
<p><strong>Example</strong></p>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="nt">&lt;TrafficSignals&gt;</span>
<span class="w">  </span><span class="nt">&lt;TrafficSignalController</span><span class="w"> </span><span class="na">name=</span><span class="s">&quot;&quot;</span><span class="nt">&gt;</span>
<span class="w">    </span><span class="nt">&lt;Phase</span><span class="w"> </span><span class="na">duration=</span><span class="s">&quot;3&quot;</span><span class="w"> </span><span class="na">name=</span><span class="s">&quot;Phase1&quot;</span><span class="nt">&gt;</span>
<span class="w">      </span><span class="nt">&lt;TrafficSignalState</span><span class="w"> </span><span class="na">state=</span><span class="s">&quot;green&quot;</span><span class="w"> </span><span class="na">trafficSignalId=</span><span class="s">&quot;1&quot;</span><span class="nt">/&gt;</span>
<span class="w">    </span><span class="nt">&lt;/Phase&gt;</span>
<span class="w">    </span><span class="nt">&lt;Phase</span><span class="w"> </span><span class="na">duration=</span><span class="s">&quot;3&quot;</span><span class="w"> </span><span class="na">name=</span><span class="s">&quot;Phase2&quot;</span><span class="nt">&gt;</span>
<span class="w">      </span><span class="nt">&lt;TrafficSignalState</span><span class="w"> </span><span class="na">state=</span><span class="s">&quot;yellow&quot;</span><span class="w"> </span><span class="na">trafficSignalId=</span><span class="s">&quot;1&quot;</span><span class="nt">/&gt;</span>
<span class="w">    </span><span class="nt">&lt;/Phase&gt;</span>
<span class="w">    </span><span class="nt">&lt;Phase</span><span class="w"> </span><span class="na">duration=</span><span class="s">&quot;3&quot;</span><span class="w"> </span><span class="na">name=</span><span class="s">&quot;Phase3&quot;</span><span class="nt">&gt;</span>
<span class="w">      </span><span class="nt">&lt;TrafficSignalState</span><span class="w"> </span><span class="na">state=</span><span class="s">&quot;red&quot;</span><span class="w"> </span><span class="na">trafficSignalId=</span><span class="s">&quot;1&quot;</span><span class="nt">/&gt;</span>
<span class="w">    </span><span class="nt">&lt;/Phase&gt;</span>
<span class="w">    </span><span class="nt">&lt;Phase</span><span class="w"> </span><span class="na">duration=</span><span class="s">&quot;3&quot;</span><span class="w"> </span><span class="na">name=</span><span class="s">&quot;Phase4&quot;</span><span class="nt">&gt;</span>
<span class="w">      </span><span class="nt">&lt;TrafficSignalState</span><span class="w"> </span><span class="na">state=</span><span class="s">&quot;red yellow&quot;</span><span class="w"> </span><span class="na">trafficSignalId=</span><span class="s">&quot;1&quot;</span><span class="nt">/&gt;</span>
<span class="w">    </span><span class="nt">&lt;/Phase&gt;</span>
<span class="w">  </span><span class="nt">&lt;/TrafficSignalController&gt;</span>
<span class="nt">&lt;/TrafficSignals&gt;</span>
</pre></div>
</div>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Supported States</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>off</p></td>
</tr>
<tr class="row-odd"><td><p>red</p></td>
</tr>
<tr class="row-even"><td><p>yellow</p></td>
</tr>
<tr class="row-odd"><td><p>green</p></td>
</tr>
<tr class="row-even"><td><p>red yellow</p></td>
</tr>
<tr class="row-odd"><td><p>yellow flashing</p></td>
</tr>
</tbody>
</table>
</section>
<section id="entities">
<span id="scenario-entities"></span><h2>Entities<a class="headerlink" href="#entities" title="Link to this heading"></a></h2>
<p>The <code class="docutils literal notranslate"><span class="pre">Entities</span></code> tag defines all agents that are present at the start of the simulation at predefined positions.
There may be any number of these so called <strong>Scenario Agents</strong> (also zero).</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>EntitySelections are currently not supported by the OpenScenarioEngine</p>
</div>
<p>An entity consits of a <code class="docutils literal notranslate"><span class="pre">VehicleModel</span></code> (typically a reference an entry from the VehicleCatalog) and a controller.
The controller is <strong>optional</strong> and if no controller is specified, a <em>default</em> contoller will be instantiated, which strictly follows OpenSCENARIO actions as requested by the standard.
Unless requested differently through specific actions, it follows the <em>default</em> behaviors <cite>KeepVelocity</cite> and <cite>KeepLateralOffset</cite>.
To use the openPASS specific scenario controller a controller with a single parameter named <code class="docutils literal notranslate"><span class="pre">AgentProfile</span></code> needs to be specified.</p>
<div class="admonition-agentprofile-and-profilescatalog admonition">
<p class="admonition-title">AgentProfile and ProfilesCatalog</p>
<p>The <code class="docutils literal notranslate"><span class="pre">AgentProfile</span></code> links to a profile in the mandatory <code class="docutils literal notranslate"><span class="pre">ProfilesCatalog.xml</span></code> (see <a class="reference internal" href="profilescatalog.html#profilescatalog"><span class="std std-ref">ProfilesCatalog</span></a>).
This is an extension w.r.t. the OpenSCENARIO standard, as the standard currently does not allow to specifiy a stochastic composition of entities.</p>
</div>
<p><strong>Example</strong></p>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="nt">&lt;Entities&gt;</span>
<span class="w">  </span><span class="nt">&lt;ScenarioObject</span><span class="w"> </span><span class="na">name=</span><span class="s">&quot;Ego&quot;</span><span class="nt">&gt;</span>
<span class="w">    </span><span class="nt">&lt;CatalogReference</span><span class="w"> </span><span class="na">catalogName=</span><span class="s">&quot;VehicleCatalog&quot;</span><span class="w"> </span><span class="na">entryName=</span><span class="s">&quot;car_mini_cooper&quot;</span><span class="nt">/&gt;</span>
<span class="w">    </span><span class="nt">&lt;ObjectController&gt;</span>
<span class="w">      </span><span class="nt">&lt;Controller</span><span class="w"> </span><span class="na">name=</span><span class="s">&quot;Ego&quot;</span><span class="nt">&gt;</span>
<span class="w">        </span><span class="nt">&lt;Properties&gt;</span>
<span class="w">          </span><span class="nt">&lt;Property</span><span class="w"> </span><span class="na">name=</span><span class="s">&quot;AgentProfile&quot;</span><span class="w"> </span><span class="na">value=</span><span class="s">&quot;MiddleClassCarAgent&quot;</span><span class="nt">/&gt;</span>
<span class="w">        </span><span class="nt">&lt;/Properties&gt;</span>
<span class="w">      </span><span class="nt">&lt;/Controller&gt;</span>
<span class="w">    </span><span class="nt">&lt;/ObjectController&gt;</span>
<span class="w">  </span><span class="nt">&lt;/ScenarioObject&gt;</span>
<span class="nt">&lt;/Entities&gt;</span>
</pre></div>
</div>
<p><strong>Overriding Parameters</strong></p>
<p>Parameters defined in the VehicleCatalog can be assigned inside the CatalogReference element.
In this case the assigned parameter will overwrite the definition in the VehicleCatalog.
Otherwise the value defined in the VehicleCatalog is used.
The type of the parameter must match that in the VehicleCatalog.</p>
<p><strong>Example</strong></p>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="nt">&lt;CatalogReference</span><span class="w"> </span><span class="na">catalogName=</span><span class="s">&quot;VehicleCatalog&quot;</span><span class="w"> </span><span class="na">entryName=</span><span class="s">&quot;car_mini_cooper&quot;</span><span class="nt">&gt;</span>
<span class="w">    </span><span class="nt">&lt;ParameterAssignments&gt;</span>
<span class="w">        </span><span class="nt">&lt;ParameterAssignment</span><span class="w"> </span><span class="na">parameterRef=</span><span class="s">&quot;Length&quot;</span><span class="w"> </span><span class="na">value=</span><span class="s">&quot;4.0&quot;</span><span class="w"> </span><span class="nt">/&gt;</span>
<span class="w">    </span><span class="nt">&lt;/ParameterAssignments&gt;</span>
<span class="nt">&lt;/CatalogReference&gt;</span>
</pre></div>
</div>
</section>
<section id="storyboard">
<span id="scenario-storyboard"></span><h2>Storyboard<a class="headerlink" href="#storyboard" title="Link to this heading"></a></h2>
<p>The <code class="docutils literal notranslate"><span class="pre">Storyboard</span></code> tag contains the initial setup of the scenario and manipulator actions.
These actions control the behavior of the simulation at runtime based on predefined conditions.
In short it is divided into an <code class="docutils literal notranslate"><span class="pre">Init</span></code> phase, an actual <code class="docutils literal notranslate"><span class="pre">Story</span></code>, and a <code class="docutils literal notranslate"><span class="pre">StopTrigger</span></code>.</p>
<p>For the definition of the storyboard please refert to the <a class="reference external" href="https://www.asam.net/static_downloads/ASAM_OpenSCENARIO_V1.1.1_Model_Documentation/modelDocumentation/">OpenSCENARIO 1.1.1 Model Definition</a>.</p>
<p>In the following sections, clarifications with respect to <strong>openPASS</strong> will be given:</p>
<section id="init">
<span id="scenario-init"></span><h3>Init<a class="headerlink" href="#init" title="Link to this heading"></a></h3>
<p>As desribed above, agents need to be defined in the <code class="docutils literal notranslate"><span class="pre">Entities</span></code> section.
For proper spawning they need to be parameterized within the <code class="docutils literal notranslate"><span class="pre">Init</span></code> phase:</p>
<ul class="simple">
<li><p>A <a class="reference external" href="https://www.asam.net/static_downloads/ASAM_OpenSCENARIO_V1.1.1_Model_Documentation/modelDocumentation/content/TeleportAction.html">TeleportAction</a> specifies the initial position
If no TeleportAction is defined the agent will not be spawned (the TeleportAction can also happen inside the <code class="docutils literal notranslate"><span class="pre">Story</span></code>).</p></li>
<li><p>A <a class="reference external" href="https://www.asam.net/static_downloads/ASAM_OpenSCENARIO_V1.1.1_Model_Documentation/modelDocumentation/content/SpeedAction.html">SpeedAction</a> specifies the desired velocity.
[optional] If not defined, a spawned agent will start at standstill.</p></li>
<li><p>A <a class="reference external" href="https://www.asam.net/static_downloads/ASAM_OpenSCENARIO_V1.1.1_Model_Documentation/modelDocumentation/content/FollowRouteAction.html">FollowRouteAction</a> forces the agent onto a specific trajectory
[optional] If not defined, a random route will be assigned.</p></li>
</ul>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>VisiblilityAction is currently not supported by <strong>openPASS</strong></p>
</div>
<p><strong>Example: TeleportAction + SpeedAction</strong></p>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="nt">&lt;Init&gt;</span>
<span class="w">  </span><span class="nt">&lt;Actions&gt;</span>
<span class="w">    </span><span class="nt">&lt;Private</span><span class="w"> </span><span class="na">entityRef=</span><span class="s">&quot;Ego&quot;</span><span class="nt">&gt;</span>
<span class="w">      </span><span class="nt">&lt;PrivateAction&gt;</span>
<span class="w">        </span><span class="nt">&lt;TeleportAction&gt;</span>
<span class="w">          </span><span class="nt">&lt;Position&gt;</span>
<span class="w">            </span><span class="nt">&lt;LanePosition</span><span class="w"> </span><span class="na">roadId=</span><span class="s">&quot;1&quot;</span><span class="w"> </span><span class="na">laneId=</span><span class="s">&quot;-1&quot;</span><span class="w"> </span><span class="na">offset=</span><span class="s">&quot;0.0&quot;</span><span class="w"> </span><span class="na">s=</span><span class="s">&quot;0.0&quot;</span><span class="nt">&gt;</span>
<span class="w">              </span><span class="nt">&lt;Orientation</span><span class="w"> </span><span class="na">type=</span><span class="s">&quot;relative&quot;</span><span class="nt">/&gt;</span>
<span class="w">            </span><span class="nt">&lt;/LanePosition&gt;</span>
<span class="w">          </span><span class="nt">&lt;/Position&gt;</span>
<span class="w">        </span><span class="nt">&lt;/TeleportAction&gt;</span>
<span class="w">      </span><span class="nt">&lt;/PrivateAction&gt;</span>
<span class="w">      </span><span class="nt">&lt;PrivateAction&gt;</span>
<span class="w">        </span><span class="nt">&lt;LongitudinalAction&gt;</span>
<span class="w">          </span><span class="nt">&lt;SpeedAction&gt;</span>
<span class="w">            </span><span class="nt">&lt;SpeedActionDynamics</span><span class="w"> </span><span class="na">dynamicsShape=</span><span class="s">&quot;step&quot;</span><span class="w"> </span><span class="na">value=</span><span class="s">&quot;0.0&quot;</span><span class="w"> </span><span class="na">dynamicsDimension=</span><span class="s">&quot;rate&quot;</span><span class="nt">/&gt;</span>
<span class="w">            </span><span class="nt">&lt;SpeedActionTarget&gt;</span>
<span class="w">              </span><span class="nt">&lt;AbsoluteTargetSpeed</span><span class="w"> </span><span class="na">value=</span><span class="s">&quot;43.5&quot;</span><span class="nt">/&gt;</span>
<span class="w">            </span><span class="nt">&lt;/SpeedActionTarget&gt;</span>
<span class="w">          </span><span class="nt">&lt;/SpeedAction&gt;</span>
<span class="w">        </span><span class="nt">&lt;/LongitudinalAction&gt;</span>
<span class="w">      </span><span class="nt">&lt;/PrivateAction&gt;</span>
<span class="w">      </span><span class="nt">&lt;PrivateAction&gt;</span>
<span class="w">        </span><span class="nt">&lt;ControllerAction&gt;</span>
<span class="w">          </span><span class="nt">&lt;ActivateControllerAction</span><span class="w"> </span><span class="na">controllerRef=</span><span class="s">&quot;Ego&quot;</span><span class="w"> </span><span class="na">lateral=</span><span class="s">&quot;true&quot;</span><span class="w"> </span><span class="na">longitudinal=</span><span class="s">&quot;true&quot;</span><span class="w"> </span><span class="nt">/&gt;</span>
<span class="w">        </span><span class="nt">&lt;/ControllerAction&gt;</span>
<span class="w">      </span><span class="nt">&lt;/PrivateAction&gt;</span>
<span class="w">    </span><span class="nt">&lt;/Private&gt;</span>
<span class="w">  </span><span class="nt">&lt;/Actions&gt;</span>
<span class="nt">&lt;/Init&gt;</span>
</pre></div>
</div>
<p><strong>Example: TeleportAction + FollowRouteAction</strong></p>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="nt">&lt;Init&gt;</span>
<span class="w">  </span><span class="nt">&lt;Actions&gt;</span>
<span class="w">    </span><span class="nt">&lt;Private</span><span class="w"> </span><span class="na">entityRef=</span><span class="s">&quot;Ego&quot;</span><span class="nt">&gt;</span>
<span class="w">      </span><span class="nt">&lt;PrivateAction&gt;</span>
<span class="w">        </span><span class="nt">&lt;TeleportAction&gt;</span>
<span class="w">          </span><span class="nt">&lt;Position&gt;</span>
<span class="w">            </span><span class="nt">&lt;LanePosition</span><span class="w"> </span><span class="na">roadId=</span><span class="s">&quot;1472558076&quot;</span><span class="w"> </span><span class="na">laneId=</span><span class="s">&quot;-1&quot;</span><span class="w"> </span><span class="na">offset=</span><span class="s">&quot;0.0&quot;</span><span class="w"> </span><span class="na">s=</span><span class="s">&quot;200.0&quot;</span><span class="nt">&gt;</span>
<span class="w">              </span><span class="nt">&lt;Orientation</span><span class="w"> </span><span class="na">type=</span><span class="s">&quot;relative&quot;</span><span class="nt">/&gt;</span>
<span class="w">            </span><span class="nt">&lt;/LanePosition&gt;</span>
<span class="w">          </span><span class="nt">&lt;/Position&gt;</span>
<span class="w">        </span><span class="nt">&lt;/TeleportAction&gt;</span>
<span class="w">      </span><span class="nt">&lt;/PrivateAction&gt;</span>
<span class="w">      </span><span class="nt">&lt;PrivateAction&gt;</span>
<span class="w">        </span><span class="nt">&lt;RoutingAction&gt;</span>
<span class="w">          </span><span class="nt">&lt;AssignRouteAction&gt;</span>
<span class="w">            </span><span class="nt">&lt;Route</span><span class="w"> </span><span class="na">closed=</span><span class="s">&quot;false&quot;</span><span class="w"> </span><span class="na">name=</span><span class="s">&quot;&quot;</span><span class="nt">&gt;</span>
<span class="w">              </span><span class="nt">&lt;Waypoint</span><span class="w"> </span><span class="na">routeStrategy=</span><span class="s">&quot;fastest&quot;</span><span class="nt">&gt;</span>
<span class="w">                </span><span class="nt">&lt;Position&gt;</span>
<span class="w">                  </span><span class="nt">&lt;RoadPosition</span><span class="w"> </span><span class="na">roadId=</span><span class="s">&quot;1472558076&quot;</span><span class="w"> </span><span class="na">t=</span><span class="s">&quot;-1.0&quot;</span><span class="w"> </span><span class="na">s=</span><span class="s">&quot;230&quot;</span><span class="nt">/&gt;</span>
<span class="w">                </span><span class="nt">&lt;/Position&gt;</span>
<span class="w">              </span><span class="nt">&lt;/Waypoint&gt;</span>
<span class="w">              </span><span class="nt">&lt;Waypoint</span><span class="w"> </span><span class="na">routeStrategy=</span><span class="s">&quot;fastest&quot;</span><span class="nt">&gt;</span>
<span class="w">                </span><span class="nt">&lt;Position&gt;</span>
<span class="w">                  </span><span class="nt">&lt;RoadPosition</span><span class="w"> </span><span class="na">roadId=</span><span class="s">&quot;3083973&quot;</span><span class="w"> </span><span class="na">t=</span><span class="s">&quot;-1.0&quot;</span><span class="w"> </span><span class="na">s=</span><span class="s">&quot;8.5&quot;</span><span class="nt">/&gt;</span>
<span class="w">                </span><span class="nt">&lt;/Position&gt;</span>
<span class="w">              </span><span class="nt">&lt;/Waypoint&gt;</span>
<span class="w">              </span><span class="nt">&lt;Waypoint</span><span class="w"> </span><span class="na">routeStrategy=</span><span class="s">&quot;fastest&quot;</span><span class="nt">&gt;</span>
<span class="w">                </span><span class="nt">&lt;Position&gt;</span>
<span class="w">                  </span><span class="nt">&lt;RoadPosition</span><span class="w"> </span><span class="na">roadId=</span><span class="s">&quot;2015840166&quot;</span><span class="w"> </span><span class="na">t=</span><span class="s">&quot;-0.2&quot;</span><span class="w"> </span><span class="na">s=</span><span class="s">&quot;100&quot;</span><span class="nt">/&gt;</span>
<span class="w">                </span><span class="nt">&lt;/Position&gt;</span>
<span class="w">              </span><span class="nt">&lt;/Waypoint&gt;</span>
<span class="w">            </span><span class="nt">&lt;/Route&gt;</span>
<span class="w">          </span><span class="nt">&lt;/AssignRouteAction&gt;</span>
<span class="w">        </span><span class="nt">&lt;/RoutingAction&gt;</span>
<span class="w">      </span><span class="nt">&lt;/PrivateAction&gt;</span>
<span class="w">      </span><span class="nt">&lt;PrivateAction&gt;</span>
<span class="w">        </span><span class="nt">&lt;ControllerAction&gt;</span>
<span class="w">          </span><span class="nt">&lt;ActivateControllerAction</span><span class="w"> </span><span class="na">lateral=</span><span class="s">&quot;true&quot;</span><span class="w"> </span><span class="na">longitudinal=</span><span class="s">&quot;true&quot;</span><span class="w"> </span><span class="na">controllerRef=</span><span class="s">&quot;Ego&quot;</span><span class="nt">/&gt;</span>
<span class="w">        </span><span class="nt">&lt;/ControllerAction&gt;</span>
<span class="w">      </span><span class="nt">&lt;/PrivateAction&gt;</span>
<span class="w">    </span><span class="nt">&lt;/Private&gt;</span>
<span class="w">  </span><span class="nt">&lt;/Actions&gt;</span>
<span class="nt">&lt;/Init&gt;</span>
</pre></div>
</div>
</section>
<section id="story">
<span id="scenario-story"></span><h3>Story<a class="headerlink" href="#story" title="Link to this heading"></a></h3>
<p>The tag <code class="docutils literal notranslate"><span class="pre">Story</span></code> is optional and defines all conditional interventions during runtime.
Please refer to the <a class="reference external" href="https://www.asam.net/static_downloads/ASAM_OpenSCENARIO_V1.2.0_Model_Documentation/modelDocumentation/content/Storyboard.html">Model Documentation</a> for a general overview and the <a class="reference external" href="https://gitlab.eclipse.org/eclipse/openpass/openscenario1_engine">OpenScenarioEngine</a> for supported actions and conditions within a story.</p>
</section>
<section id="stoptrigger">
<h3>StopTrigger<a class="headerlink" href="#stoptrigger" title="Link to this heading"></a></h3>
<p>It is <strong>mandatory</strong> for openPASS to define a StopTrigger that will fire in any case (otherwise, the simulation will never stop).
This does not necessarily have to be a SimulationTimeCondition, but it is recommended to use it, perhaps in conjunction with another trigger.</p>
</section>
</section>
<section id="current-restrictions">
<h2>Current Restrictions<a class="headerlink" href="#current-restrictions" title="Link to this heading"></a></h2>
<section id="conditions">
<h3>Conditions<a class="headerlink" href="#conditions" title="Link to this heading"></a></h3>
<p><strong>openPASS</strong> support different kind of conditions, belonging either to <code class="docutils literal notranslate"><span class="pre">ByValueCondition</span></code> or <code class="docutils literal notranslate"><span class="pre">ByEntityCondition</span></code>.
While a <strong>by value condition</strong> triggers based on a specified value and is unrelated to any specific agent, a <strong>by entity condition</strong> is bound to an triggering agent, defined by a mandatory section <code class="docutils literal notranslate"><span class="pre">TriggeringEntities</span></code>.
Entities can be either ego or scenario agents.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Reacting on “common” cars is currently not supported.</p>
</div>
</section>
<section id="actions">
<h3>Actions<a class="headerlink" href="#actions" title="Link to this heading"></a></h3>
<p>The following OpenSCENARIO actions are supported:</p>
<ul class="simple">
<li><p><a class="reference internal" href="#scenario-followrouteaction"><span class="std std-ref">FollowRouteAction</span></a></p></li>
<li><p><a class="reference internal" href="#scenario-lanechange"><span class="std std-ref">LaneChangeAction</span></a></p></li>
<li><p><a class="reference internal" href="#scenario-followtrajectory"><span class="std std-ref">FollowTrajectoryAction</span></a></p></li>
<li><p><a class="reference internal" href="#scenario-acquireposition"><span class="std std-ref">AcquirePositionAction</span></a></p></li>
<li><p><a class="reference internal" href="#scenario-teleportaction"><span class="std std-ref">TeleportAction</span></a></p></li>
<li><p><a class="reference internal" href="#scenario-speedaction"><span class="std std-ref">SpeedAction</span></a></p></li>
<li><p><a class="reference internal" href="#scenario-trafficsinkaction"><span class="std std-ref">TrafficSinkAction</span></a></p></li>
</ul>
<p>In addition, the following user defined actions are interpreted:</p>
<ul class="simple">
<li><p><a class="reference internal" href="#scenario-componentstatechange"><span class="std std-ref">SetComponentState (UserDefinedAction)</span></a></p></li>
<li><p><a class="reference internal" href="#scenario-defaultcustomcommandaction"><span class="std std-ref">DefaultCustomCommandAction (UserDefinedAction)</span></a></p></li>
</ul>
<section id="scenario-followrouteaction">
<span id="id3"></span><h4>FollowRouteAction<a class="headerlink" href="#scenario-followrouteaction" title="Link to this heading"></a></h4>
<p>The FollowRouteAction is mainly used as part of the <code class="docutils literal notranslate"><span class="pre">Init</span></code> phase of the Storyboard.
It defines Waypoints, which are located by <code class="docutils literal notranslate"><span class="pre">road_id</span></code> and further with <code class="docutils literal notranslate"><span class="pre">s</span></code> and <code class="docutils literal notranslate"><span class="pre">t</span></code> coordinates.
The Agent will try to follow the specified points.</p>
<p><strong>Example</strong> <em>Right turn, by specifying three waypoints</em></p>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="w">          </span><span class="nt">&lt;RoutingAction&gt;</span>
<span class="w">            </span><span class="nt">&lt;AssignRouteAction&gt;</span>
<span class="w">              </span><span class="nt">&lt;Route</span><span class="w"> </span><span class="na">closed=</span><span class="s">&quot;false&quot;</span><span class="w"> </span><span class="na">name=</span><span class="s">&quot;&quot;</span><span class="nt">&gt;</span>
<span class="w">                </span><span class="nt">&lt;Waypoint</span><span class="w"> </span><span class="na">routeStrategy=</span><span class="s">&quot;fastest&quot;</span><span class="nt">&gt;</span>
<span class="w">                  </span><span class="nt">&lt;Position&gt;</span>
<span class="w">                    </span><span class="nt">&lt;RoadPosition</span><span class="w"> </span><span class="na">roadId=</span><span class="s">&quot;1472558076&quot;</span><span class="w"> </span><span class="na">t=</span><span class="s">&quot;-1.0&quot;</span><span class="w"> </span><span class="na">s=</span><span class="s">&quot;230&quot;</span><span class="nt">/&gt;</span>
<span class="w">                  </span><span class="nt">&lt;/Position&gt;</span>
<span class="w">                </span><span class="nt">&lt;/Waypoint&gt;</span>
<span class="w">                </span><span class="nt">&lt;Waypoint</span><span class="w"> </span><span class="na">routeStrategy=</span><span class="s">&quot;fastest&quot;</span><span class="nt">&gt;</span>
<span class="w">                  </span><span class="nt">&lt;Position&gt;</span>
<span class="w">                    </span><span class="nt">&lt;RoadPosition</span><span class="w"> </span><span class="na">roadId=</span><span class="s">&quot;3083973&quot;</span><span class="w"> </span><span class="na">t=</span><span class="s">&quot;-1.0&quot;</span><span class="w"> </span><span class="na">s=</span><span class="s">&quot;8.5&quot;</span><span class="nt">/&gt;</span>
<span class="w">                  </span><span class="nt">&lt;/Position&gt;</span>
<span class="w">                </span><span class="nt">&lt;/Waypoint&gt;</span>
<span class="w">                </span><span class="nt">&lt;Waypoint</span><span class="w"> </span><span class="na">routeStrategy=</span><span class="s">&quot;fastest&quot;</span><span class="nt">&gt;</span>
<span class="w">                  </span><span class="nt">&lt;Position&gt;</span>
<span class="w">                    </span><span class="nt">&lt;RoadPosition</span><span class="w"> </span><span class="na">roadId=</span><span class="s">&quot;2015840166&quot;</span><span class="w"> </span><span class="na">t=</span><span class="s">&quot;-0.2&quot;</span><span class="w"> </span><span class="na">s=</span><span class="s">&quot;100&quot;</span><span class="nt">/&gt;</span>
<span class="w">                  </span><span class="nt">&lt;/Position&gt;</span>
<span class="w">                </span><span class="nt">&lt;/Waypoint&gt;</span>
<span class="w">              </span><span class="nt">&lt;/Route&gt;</span>
<span class="w">            </span><span class="nt">&lt;/AssignRouteAction&gt;</span>
<span class="w">          </span><span class="nt">&lt;/RoutingAction&gt;</span>
</pre></div>
</div>
</section>
<section id="lanechangeaction">
<span id="scenario-lanechange"></span><h4>LaneChangeAction<a class="headerlink" href="#lanechangeaction" title="Link to this heading"></a></h4>
<p>If this action triggers, the actor is forced to perform a trajectory, calculated at the time of triggering.
The target lane be given either absolute or with respect to another entity.
The trajectory can either have a fixed length (in <code class="docutils literal notranslate"><span class="pre">s</span></code>) or a fixed time.</p>
<p>Currently <strong>openPASS</strong> only supports the type <code class="docutils literal notranslate"><span class="pre">sinusoidal</span></code>.</p>
<p><strong>Example</strong> <em>with absolute target and fixed length</em></p>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="nt">&lt;Action</span><span class="w"> </span><span class="na">name=</span><span class="s">&quot;LaneChange&quot;</span><span class="nt">&gt;</span>
<span class="w">  </span><span class="nt">&lt;PrivateAction&gt;</span>
<span class="w">    </span><span class="nt">&lt;LateralAction&gt;</span>
<span class="w">      </span><span class="nt">&lt;LaneChangeAction&gt;</span>
<span class="w">        </span><span class="nt">&lt;LaneChangeActionDynamics</span><span class="w"> </span><span class="na">value=</span><span class="s">&quot;2.0&quot;</span><span class="w"> </span><span class="na">dynamicsShape=</span><span class="s">&quot;sinusoidal&quot;</span><span class="w"> </span><span class="na">dynamicsDimension=</span><span class="s">&quot;time&quot;</span><span class="nt">/&gt;</span>
<span class="w">        </span><span class="nt">&lt;LaneChangeTarget&gt;</span>
<span class="w">          </span><span class="nt">&lt;AbsoluteTargetLane</span><span class="w"> </span><span class="na">value=</span><span class="s">&quot;-4&quot;</span><span class="nt">/&gt;</span>
<span class="w">        </span><span class="nt">&lt;/LaneChangeTarget&gt;</span>
<span class="w">      </span><span class="nt">&lt;/LaneChangeAction&gt;</span>
<span class="w">    </span><span class="nt">&lt;/LateralAction&gt;</span>
<span class="w">  </span><span class="nt">&lt;/PrivateAction&gt;</span>
<span class="nt">&lt;/Action&gt;</span>
</pre></div>
</div>
<p><strong>Example</strong> <em>with relative target and fixed time</em></p>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="nt">&lt;Action</span><span class="w"> </span><span class="na">name=</span><span class="s">&quot;LaneChange&quot;</span><span class="nt">&gt;</span>
<span class="w">  </span><span class="nt">&lt;PrivateAction&gt;</span>
<span class="w">    </span><span class="nt">&lt;LateralAction&gt;</span>
<span class="w">      </span><span class="nt">&lt;LaneChangeAction&gt;</span>
<span class="w">        </span><span class="nt">&lt;LaneChangeActionDynamics</span><span class="w"> </span><span class="na">value=</span><span class="s">&quot;2.0&quot;</span><span class="w"> </span><span class="na">dynamicsShape=</span><span class="s">&quot;sinusoidal&quot;</span><span class="w"> </span><span class="na">dynamicsDimension=</span><span class="s">&quot;time&quot;</span><span class="nt">/&gt;</span>
<span class="w">        </span><span class="nt">&lt;LaneChangeTarget&gt;</span>
<span class="w">          </span><span class="nt">&lt;RelativeTargetLane</span><span class="w"> </span><span class="na">entityRef=</span><span class="s">&quot;Ego&quot;</span><span class="w"> </span><span class="na">value=</span><span class="s">&quot;+1&quot;</span><span class="nt">/&gt;</span>
<span class="w">        </span><span class="nt">&lt;/LaneChangeTarget&gt;</span>
<span class="w">      </span><span class="nt">&lt;/LaneChangeAction&gt;</span>
<span class="w">    </span><span class="nt">&lt;/LateralAction&gt;</span>
<span class="w">  </span><span class="nt">&lt;/PrivateAction&gt;</span>
<span class="nt">&lt;/Action&gt;</span>
</pre></div>
</div>
</section>
<section id="followtrajectoryaction">
<span id="scenario-followtrajectory"></span><h4>FollowTrajectoryAction<a class="headerlink" href="#followtrajectoryaction" title="Link to this heading"></a></h4>
<p>If triggered, the defined trajectory is relayed as signal to listening components.
The trajectory can be defined either directly in the story or as separate TrajectoryCatalog.
For the points (vertices) of the trajectory only world coordinates, given as <code class="docutils literal notranslate"><span class="pre">openScenario::WorldPosition</span></code>, are supported.
Right now, the mandatory attributes  <em>z</em>, <em>pitch</em> and <em>roll</em> are ignored.</p>
<p><strong>Example</strong></p>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="nt">&lt;Action</span><span class="w"> </span><span class="na">name=</span><span class="s">&quot;Trajectory&quot;</span><span class="nt">&gt;</span>
<span class="w">  </span><span class="nt">&lt;PrivateAction&gt;</span>
<span class="w">    </span><span class="nt">&lt;RoutingAction&gt;</span>
<span class="w">      </span><span class="nt">&lt;FollowTrajectoryAction&gt;</span>
<span class="w">        </span><span class="nt">&lt;TrajectoryRef&gt;</span>
<span class="w">          </span><span class="nt">&lt;Trajectory</span><span class="w"> </span><span class="na">name=</span><span class="s">&quot;LaneChange&quot;</span><span class="w"> </span><span class="na">closed=</span><span class="s">&quot;false&quot;</span><span class="nt">&gt;</span>
<span class="w">            </span><span class="nt">&lt;Shape&gt;</span>
<span class="w">              </span><span class="nt">&lt;Polyline&gt;</span>
<span class="w">                </span><span class="nt">&lt;Vertex</span><span class="w"> </span><span class="na">time=</span><span class="s">&quot;0&quot;</span><span class="nt">&gt;</span>
<span class="w">                  </span><span class="nt">&lt;Position&gt;</span>
<span class="w">                    </span><span class="nt">&lt;WorldPosition</span><span class="w"> </span><span class="na">x=</span><span class="s">&quot;100&quot;</span><span class="w"> </span><span class="na">y=</span><span class="s">&quot;3&quot;</span><span class="w"> </span><span class="na">z=</span><span class="s">&quot;0&quot;</span><span class="w"> </span><span class="na">h=</span><span class="s">&quot;1.570796326&quot;</span><span class="w"> </span><span class="na">p=</span><span class="s">&quot;0&quot;</span><span class="w"> </span><span class="na">r=</span><span class="s">&quot;0&quot;</span><span class="nt">/&gt;</span>
<span class="w">                  </span><span class="nt">&lt;/Position&gt;</span>
<span class="w">                </span><span class="nt">&lt;/Vertex&gt;</span>
<span class="w">                </span><span class="nt">&lt;Vertex</span><span class="w"> </span><span class="na">time=</span><span class="s">&quot;5&quot;</span><span class="nt">&gt;</span>
<span class="w">                  </span><span class="nt">&lt;Position&gt;</span>
<span class="w">                    </span><span class="nt">&lt;WorldPosition</span><span class="w"> </span><span class="na">x=</span><span class="s">&quot;100&quot;</span><span class="w"> </span><span class="na">y=</span><span class="s">&quot;8&quot;</span><span class="w"> </span><span class="na">z=</span><span class="s">&quot;0&quot;</span><span class="w"> </span><span class="na">h=</span><span class="s">&quot;1.570796326&quot;</span><span class="w"> </span><span class="na">p=</span><span class="s">&quot;0&quot;</span><span class="w"> </span><span class="na">r=</span><span class="s">&quot;0&quot;</span><span class="nt">/&gt;</span>
<span class="w">                  </span><span class="nt">&lt;/Position&gt;</span>
<span class="w">                </span><span class="nt">&lt;/Vertex&gt;</span>
<span class="w">              </span><span class="nt">&lt;/Polyline&gt;</span>
<span class="w">            </span><span class="nt">&lt;/Shape&gt;</span>
<span class="w">          </span><span class="nt">&lt;/Trajectory&gt;</span>
<span class="w">        </span><span class="nt">&lt;/TrajectoryRef&gt;</span>
<span class="w">        </span><span class="nt">&lt;TimeReference&gt;</span>
<span class="w">          </span><span class="nt">&lt;None/&gt;</span>
<span class="w">        </span><span class="nt">&lt;/TimeReference&gt;</span>
<span class="w">        </span><span class="nt">&lt;TrajectoryFollowingMode</span><span class="w"> </span><span class="na">followingMode=</span><span class="s">&quot;position&quot;</span><span class="nt">/&gt;</span>
<span class="w">      </span><span class="nt">&lt;/FollowTrajectoryAction&gt;</span>
<span class="w">    </span><span class="nt">&lt;/RoutingAction&gt;</span>
<span class="w">  </span><span class="nt">&lt;/PrivateAction&gt;</span>
<span class="nt">&lt;/Action&gt;</span>
</pre></div>
</div>
<p><strong>Example</strong> <em>using a TrajectoryCatalog</em></p>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="nt">&lt;Action</span><span class="w"> </span><span class="na">name=</span><span class="s">&quot;FollowTrajectory&quot;</span><span class="nt">&gt;</span>
<span class="w">  </span><span class="nt">&lt;Private&gt;</span>
<span class="w">    </span><span class="nt">&lt;Routing&gt;</span>
<span class="w">      </span><span class="nt">&lt;FollowTrajectoryAction&gt;</span>
<span class="w">        </span><span class="nt">&lt;CatalogReference</span><span class="w"> </span><span class="na">catalogName=</span><span class="s">&quot;TrajectoryCatalog.xosc&quot;</span><span class="w"> </span><span class="na">entryName=</span><span class="s">&quot;TrajectoryA&quot;</span><span class="nt">&gt;</span>
<span class="w">      </span><span class="nt">&lt;/FollowTrajectoryAction&gt;</span>
<span class="w">    </span><span class="nt">&lt;/Routing&gt;</span>
<span class="w">   </span><span class="nt">&lt;/Private&gt;</span>
<span class="nt">&lt;/Action&gt;</span>
</pre></div>
</div>
</section>
<section id="acquirepositionaction">
<span id="scenario-acquireposition"></span><h4>AcquirePositionAction<a class="headerlink" href="#acquirepositionaction" title="Link to this heading"></a></h4>
<p>If triggered, the defined position is relayed as signal to listening components.</p>
<div class="admonition warning">
<p class="admonition-title">Warning</p>
<p>Currently, this is only supported by the component <em>FMU_Wrapper</em> for OSMP messages.</p>
</div>
<div class="admonition warning">
<p class="admonition-title">Warning</p>
<p>An FMU might contain routing logic not visible to the openPASS simulation core.
For that reason, an equivalent <cite>RoutingAction</cite> should be set when using <cite>AcquirePosition</cite>.
Otherwise the simulation output might contain missing data for fields depending on the localization along the route (<cite>PositionRoute</cite>, <cite>TCoordinate</cite>, <cite>AgentInFront</cite>, …).</p>
</div>
<p><strong>Example</strong> <em>(WorldPosition)</em></p>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="nt">&lt;Action</span><span class="w"> </span><span class="na">name=</span><span class="s">&quot;AcquirePosition&quot;</span><span class="nt">&gt;</span>
<span class="w">  </span><span class="nt">&lt;PrivateAction&gt;</span>
<span class="w">    </span><span class="nt">&lt;RoutingAction&gt;</span>
<span class="w">      </span><span class="nt">&lt;AcquirePositionAction&gt;</span>
<span class="w">        </span><span class="nt">&lt;Position&gt;</span>
<span class="w">          </span><span class="nt">&lt;WorldPosition</span><span class="w"> </span><span class="na">x=</span><span class="s">&quot;1.0&quot;</span><span class="w"> </span><span class="na">y=</span><span class="s">&quot;2.0&quot;</span><span class="w"> </span><span class="na">z=</span><span class="s">&quot;0.0&quot;</span><span class="w"> </span><span class="na">h=</span><span class="s">&quot;3.1415&quot;</span><span class="w"> </span><span class="na">p=</span><span class="s">&quot;0.0&quot;</span><span class="w"> </span><span class="na">r=</span><span class="s">&quot;0.0&quot;</span><span class="w"> </span><span class="nt">/&gt;</span>
<span class="w">        </span><span class="nt">&lt;/Position&gt;</span>
<span class="w">      </span><span class="nt">&lt;/AcquirePositionAction&gt;</span>
<span class="w">    </span><span class="nt">&lt;/RoutingAction&gt;</span>
<span class="w">  </span><span class="nt">&lt;/PrivateAction&gt;</span>
<span class="nt">&lt;/Action&gt;</span>
</pre></div>
</div>
<p><strong>Example</strong> <em>(RelativeObjectPosition)</em></p>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="nt">&lt;Action</span><span class="w"> </span><span class="na">name=</span><span class="s">&quot;AcquirePosition&quot;</span><span class="nt">&gt;</span>
<span class="w">  </span><span class="nt">&lt;PrivateAction&gt;</span>
<span class="w">    </span><span class="nt">&lt;RoutingAction&gt;</span>
<span class="w">      </span><span class="nt">&lt;AcquirePositionAction&gt;</span>
<span class="w">        </span><span class="nt">&lt;Position&gt;</span>
<span class="w">          </span><span class="nt">&lt;RelativeObjectPosition</span><span class="w"> </span><span class="na">dx=</span><span class="s">&quot;1.0&quot;</span><span class="w"> </span><span class="na">dy=</span><span class="s">&quot;1.0&quot;</span><span class="w"> </span><span class="na">entityRef=</span><span class="s">&quot;S1&quot;</span><span class="nt">/&gt;</span>
<span class="w">        </span><span class="nt">&lt;/Position&gt;</span>
<span class="w">      </span><span class="nt">&lt;/AcquirePositionAction&gt;</span>
<span class="w">    </span><span class="nt">&lt;/RoutingAction&gt;</span>
<span class="w">  </span><span class="nt">&lt;/PrivateAction&gt;</span>
<span class="nt">&lt;/Action&gt;</span>
</pre></div>
</div>
</section>
<section id="scenario-teleportaction">
<span id="id4"></span><h4>TeleportAction<a class="headerlink" href="#scenario-teleportaction" title="Link to this heading"></a></h4>
<p>The TeleportAction instantly changes the position of an entity.</p>
</section>
<section id="trafficsinkaction">
<span id="scenario-trafficsinkaction"></span><h4>TrafficSinkAction<a class="headerlink" href="#trafficsinkaction" title="Link to this heading"></a></h4>
<p>The TrafficSinkAction is used to remove agents when they reach a certain position.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>At spawning time, the TrafficSinkAction is executed the common traffic is initiated, which means vehicles will spawn at the first timestamp in the defined zone, but are immediately removed at the next timestep.</p>
</div>
</section>
<section id="scenario-speedaction">
<span id="id5"></span><h4>SpeedAction<a class="headerlink" href="#scenario-speedaction" title="Link to this heading"></a></h4>
<p>The SpeedAction adjusts the velocity of an entity based on parameters of the SpeedAction.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>If the <strong>openPASS</strong> specific controller is used, the SpeedAction might not reflect actual values used by the simulator due to physical boundaries of the simulator.</p>
</div>
<p><strong>Example</strong> <em>AbsoulteTargetSpeed</em></p>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="nt">&lt;Action</span><span class="w"> </span><span class="na">name=</span><span class="s">&quot;SpeedAction&quot;</span><span class="nt">&gt;</span>
<span class="w">  </span><span class="nt">&lt;PrivateAction&gt;</span>
<span class="w">    </span><span class="nt">&lt;LongitudinalAction&gt;</span>
<span class="w">      </span><span class="nt">&lt;SpeedAction&gt;</span>
<span class="w">        </span><span class="nt">&lt;SpeedActionDynamics</span><span class="w"> </span><span class="na">dynamicsShape=</span><span class="s">&quot;step&quot;</span><span class="w"> </span><span class="na">value=</span><span class="s">&quot;0.0&quot;</span><span class="w"> </span><span class="na">dynamicsDimension=</span><span class="s">&quot;rate&quot;</span><span class="nt">/&gt;</span>
<span class="w">        </span><span class="nt">&lt;SpeedActionTarget&gt;</span>
<span class="w">          </span><span class="nt">&lt;AbsoluteTargetSpeed</span><span class="w"> </span><span class="na">value=</span><span class="s">&quot;20&quot;</span><span class="nt">/&gt;</span>
<span class="w">        </span><span class="nt">&lt;/SpeedActionTarget&gt;</span>
<span class="w">      </span><span class="nt">&lt;/SpeedAction&gt;</span>
<span class="w">    </span><span class="nt">&lt;/LongitudinalAction&gt;</span>
<span class="w">  </span><span class="nt">&lt;/PrivateAction&gt;</span>
<span class="nt">&lt;/Action&gt;</span>
</pre></div>
</div>
<p><strong>Example</strong> <em>RelativeTargetSpeed</em></p>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="nt">&lt;Action</span><span class="w"> </span><span class="na">name=</span><span class="s">&quot;SpeedAction&quot;</span><span class="nt">&gt;</span>
<span class="w">  </span><span class="nt">&lt;PrivateAction&gt;</span>
<span class="w">    </span><span class="nt">&lt;LongitudinalAction&gt;</span>
<span class="w">      </span><span class="nt">&lt;SpeedAction&gt;</span>
<span class="w">        </span><span class="nt">&lt;SpeedActionDynamics</span><span class="w"> </span><span class="na">dynamicsShape=</span><span class="s">&quot;step&quot;</span><span class="w"> </span><span class="na">value=</span><span class="s">&quot;0.0&quot;</span><span class="w"> </span><span class="na">dynamicsDimension=</span><span class="s">&quot;rate&quot;</span><span class="nt">/&gt;</span>
<span class="w">        </span><span class="nt">&lt;SpeedActionTarget&gt;</span>
<span class="w">          </span><span class="nt">&lt;RelativeTargetSpeed</span><span class="w"> </span><span class="na">entityRef=</span><span class="s">&quot;ScenarioAgent&quot;</span><span class="w"> </span><span class="na">value=</span><span class="s">&quot;10&quot;</span>
<span class="w">                               </span><span class="na">speedTargetValueType=</span><span class="s">&quot;delta&quot;</span><span class="w"> </span><span class="na">continuous=</span><span class="s">&quot;false&quot;</span><span class="nt">/&gt;</span>
<span class="w">        </span><span class="nt">&lt;/SpeedActionTarget&gt;</span>
<span class="w">        </span><span class="nt">&lt;/SpeedAction&gt;</span>
<span class="w">    </span><span class="nt">&lt;/LongitudinalAction&gt;</span>
<span class="w">  </span><span class="nt">&lt;/PrivateAction&gt;</span>
<span class="nt">&lt;/Action&gt;</span>
</pre></div>
</div>
</section>
<section id="setcomponentstate-userdefinedaction">
<span id="scenario-componentstatechange"></span><h4>SetComponentState (UserDefinedAction)<a class="headerlink" href="#setcomponentstate-userdefinedaction" title="Link to this heading"></a></h4>
<p>Command Keyword: <code class="docutils literal notranslate"><span class="pre">SetComponentState</span></code></p>
<p>Influences the maximum reachable state of an agent component handled by the ComponentController, i.e. it can either activate or deactivate a component.
For more details see the description of the <a class="reference internal" href="../../advanced_topics/simulator/agent_components.html#agentcomponents-componentcontroller"><span class="std std-ref">ComponentController</span></a>.</p>
<p><strong>Example</strong></p>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="nt">&lt;Action</span><span class="w"> </span><span class="na">name=</span><span class="s">&quot;ComponentStateChange&quot;</span><span class="nt">&gt;</span>
<span class="w">    </span><span class="nt">&lt;UserDefinedAction&gt;</span>
<span class="w">        </span><span class="nt">&lt;CustomCommandAction&gt;</span>SetComponentState<span class="w"> </span>Dynamics_TrajectoryFollower<span class="w"> </span>Acting<span class="nt">&lt;/CustomCommandAction&gt;</span>
<span class="w">    </span><span class="nt">&lt;/UserDefinedAction&gt;</span>
<span class="nt">&lt;/Action&gt;</span>
</pre></div>
</div>
</section>
<section id="defaultcustomcommandaction-userdefinedaction">
<span id="scenario-defaultcustomcommandaction"></span><h4>DefaultCustomCommandAction (UserDefinedAction)<a class="headerlink" href="#defaultcustomcommandaction-userdefinedaction" title="Link to this heading"></a></h4>
<p>This is <strong>the</strong> default custom command, and is always selected, if <strong>the first WORD</strong> (Keyword) in the command string is <strong>not</strong> registered as a special custom command.
The command is universally accessible across all components via <cite>ScenarioControlInterface::GetCustomCommands()</cite>, empowering users to define personalized actions tailored to their specific needs.
Once defined, the functionality of this command is unique to the user, based on their custom implementation.</p>
<div class="admonition-fmu-wrapper-component-for-osmp-messages-only admonition">
<p class="admonition-title">FMU_Wrapper component for OSMP messages only</p>
<p>The linked string signal is set as custom action of the TrafficCommand. For more information on OSMP FMUs see the <a class="reference internal" href="../sim_user_guide/components/vehicle.html#components-fmuwrapper"><span class="std std-ref">FMU Wrapper</span></a> documentation.</p>
</div>
<p><strong>Example</strong></p>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="nt">&lt;Action</span><span class="w"> </span><span class="na">name=</span><span class="s">&quot;CustomParameters&quot;</span><span class="nt">&gt;</span>
<span class="w">    </span><span class="nt">&lt;UserDefinedAction&gt;</span>
<span class="w">        </span><span class="nt">&lt;CustomCommandAction&gt;</span>Arbitrary<span class="w"> </span>String,<span class="w"> </span>e.g.<span class="w"> </span>{<span class="w"> </span>&quot;hello&quot;:<span class="w"> </span>&quot;world&quot;}<span class="nt">&lt;/CustomCommandAction&gt;</span>
<span class="w">    </span><span class="nt">&lt;/UserDefinedAction&gt;</span>
<span class="nt">&lt;/Action&gt;</span>
</pre></div>
</div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Here, “Arbitrary” is first checked, if it matches any other available Keyword for used defined actions, such as <a class="reference internal" href="#scenario-componentstatechange"><span class="std std-ref">SetComponentState (UserDefinedAction)</span></a>.</p>
</div>
</section>
</section>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="profilescatalog.html" class="btn btn-neutral float-left" title="ProfilesCatalog" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="scenario_api_support.html" class="btn btn-neutral float-right" title="Scenario API Support" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2025 openPASS Working Group.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>